// Grafikrutiner
#include <stdlib.h>
#include <stdio.h>
#include <dos.h>
#include <iostream.h>
#include <alloc.h>

typedef unsigned char byte;
typedef unsigned int word;
typedef unsigned char pal[256][3];

word VGA=0xA000;

// GRAFIK

void mode(int);                              // stter grafiklge
void loadcel(char *fnamn,byte far *where,pal &palett);  // laddar in en CEL
void loadeci(char *fnamn,word where,pal &palett);  // laddar in en ECI
void makevirt(word &adr,byte far *&virscr);  // skapar en virtuell skrm
void killvirt(byte far *kill);               // raderar en   ---||---
void screencopy(word,word);                // kopierar skrmar hit och dit
void screencopy_M(word,word);                // kopierar skrmar hit och dit
void screenpaste(int x1,int y1,int x2,int y2,int x3,int y3,word source,word dest);
void cls(byte,word);                         // rensar skrmen med valfri frg
void putpixel(word,word,byte,word);          // ritar en pixel
int getpixel(word,word,word);                // ger pixelfrgen
void line(word,word,word,word,byte,word);    // drar ett streck
void box(word,word,word,word,byte,word);     // ritar en lda
void bar(word,word,word,word,byte,word);     // ritar en ifylld lda
void waitvbl();                              // vntar ut elektronstrlen

// PALETT

void setcolor(byte,byte,byte,byte);          // stter en viss frg
void getcolor(byte,byte &r,byte &g,byte &b); // ger en viss frg
void recallpalette(pal pal1);		     // aktualliserar pal
void storepalette(pal &pal1);		     // sparar aktuell palett i pal
void setpalette(byte,byte,byte);             // stter hela paletten (rgb)
int fadein(pal pal1);                        // fadar till pal1
int fadeout(byte,byte,byte);		     // fadar till frgen rgb

// ICONS 24x20

void makeicons(word &adr,byte far *&ICON);   // skapar en ikonbank
void killicons(byte far *kill);              // raderar en --||--
void loadicons(char *fnamn,byte far *ICON,pal &palett); // laddar in en ICO-fil
void puticon(int,int,int,word,word);         // ritar ut en ikon
void puticon_F(int,int,int,word,word);       // ritar ut en ikon snabbt
void puticon_M(int,int,int,word,word);	     // ritar ut en ikon utan bakgrundsfrgen
void puticon_C(int,int,int,byte,word,word);   // ritar ut en ikon utan bakgrund i col
void puticon_MZ(int,int,int,word,word,word); // ritar ut en ikon utan bakgrundsfrgen + bakom allt p ZON
void puticon_H(int,int,int,word,word);	     // ritar ut en ikon *0.25
void putshadow(int,int,word);         	     // ritar en skugga

// ICONS 32x32

void makeicons32(word &adr,byte far *&ICON);   // skapar en ikonbank
void killicons32(byte far *kill);              // raderar en --||--
void loadicons32(char *fnamn,byte far *ICON,pal &palett); // laddar in en ICO-fil
void puticon32(int,int,int,word,word);         // ritar ut en ikon
void puticon_M32(int,int,int,word,word);	     // ritar ut en ikon utan bakgrundsfrgen


// FONTER

void makefont(word &adr,byte far *&FONT);    // skapar en fontbank
void killfont(byte far *kill);               // raderar en --||--
void loadfont(char *fnamn,byte far *FONT,pal &palett); // laddar in en FNT-fil
void text(int let,int x,int y,int col,word FONT,word DEST); // textar EN bokstav
void write(char* txt,int x,int y,int col,word FONT,word DEST); // textar FLERA
void write_O(char* txt,int x,int y,int col,int ocol,word FONT,word DEST); // textar FLERA med Outline

// UNDERFUNKTIONER TILL FUNKTIONERNA

int  sgn(int);                               // returnerar tecknet p en int




void mode(int mode)
// stter skrmlge, tex 3=text; 19=MCGA
{
  asm {
    MOV ax,mode         // stoppar mode i AX-registret
    INT 0x10            // anvnder innehllet i AX fr att initiera
  }                     // grafiklge (3=text, 19=grafik (MCGA))
}

void loadcel(char *fnamn,byte far *where,pal &palett)
// laddar in en CEL-bild i where med paletten i pal
{
  FILE *fp;
  int width[2],height[2];

  fp=fopen(fnamn,"rb");
  fseek(fp,2,SEEK_SET);
  fread(width,2,1,fp);
  fread(height,2,1,fp);
  fseek(fp,32,SEEK_SET);
  fread(palett,sizeof(pal),1,fp);
  for(int r=0;r<height[0];r++)
    fread(where-4+r*320,width[0],1,fp);
  fclose(fp);
}

void loadeci(char *fnamn,word where,pal &palett)
// laddar in en CEL-bild i where med paletten i pal
{
  FILE *fp;
  byte c;
  word i,n;
  void *cpek = &c;
  void *npek = &n;

  fp=fopen(fnamn,"rb");

  i=0;
  while (i<63999)
  {
    fread(npek,2,1,fp);
    fread(cpek,1,1,fp);
    line(i,0,i+n,0,c,where);
    i=i+n+1;
  }
  fread(palett,sizeof(pal),1,fp);
  fclose(fp);
}

void cls(byte col,word where)
// rensar skrmen med frg 'col'
{
  asm {
    MOV   ax,[where]      // stoppar adressen where i AX
    MOV   es,ax           // stoppar AX i ES
    XOR   di,di           // nollar DI
    MOV   al,[col]        // stoppar frgnummret i AL
    MOV   ah,al           // stoppar AL i AH
    MOV   cx,32000;       // flyttar 32000 words = 64000 bytes = hela skrmen
    REP   stosw           // flyttar...
  }
}

void makevirt(word &adr,byte far *&virscr)
// skapar en virtuell skrm som kan kommas t med hjlp av
// 'adr' eller virscr istllet fr VGA
{
  virscr = (byte far *) farcalloc(64000,1);

  // kolla alltid om det finns tillrckligt med minne!
  if (virscr == NULL)
  {
    asm {
      MOV  ax,3
      INT  0x10
    }
    cout << "GROTESKT! Det finns inte nog med minne i denna burk!";
    farfree(virscr);
    exit(1);
  }

  adr = FP_SEG(virscr);
}

void killvirt(byte far *kill)
// frigr minnet som skrmen 'adr' upptog
{
  farfree(kill);
}

void screencopy(word source,word dest)
// kopierar hela sources innehll till dest
{
  asm {
    PUSH    ds           // sparar DataSegmentet
    MOV     ax, [dest]   // kopierar destinationspekaren till AX
    MOV     es, ax       // stoppar AX i ES
    MOV     ax, [source] // kopierar kllpekaren till AX
    MOV     ds, ax       // stoppar AX i DS
    XOR     si, si       // nollar SI
    XOR     di, di       // nollar DI
    MOV     cx, 32000    // 32000 words skall kopieras
    REP     movsw        // kopierar words cx gnger
    POP     ds           // terstller DS
  }
}

void screencopy_M(word source,word dest)
// kopierar hela sources innehll till dest
// utom frg 0
{
  asm{
    PUSH  ds
    MOV   ax,[source]
    MOV   ds,ax
    MOV   ax,[dest]
    MOV   es,ax
    XOR   di,di
    XOR   si,si
    CLD
    XOR   bx,bx
    XOR   cx,cx
    JMP   _Rita
    }
   _Masking: asm{
    INC   si
    INC   di
    JMP   _Next
    }
   _Rita: asm{
    MOV   dl,ds:[si]
    CMP   dl,0
    JZ    _Masking
    MOVSB
    }
   _Next: asm{
    INC   cx
    CMP   cx,64000
    JNZ   _Rita

    POP   ds
  }
}

void screenpaste(int x1,int y1,int x2,int y2,int x3,int y3,word source,word dest)
// kopierar rektanglen (x1,y1)-(x2,y2) frn source till (x3,y3) dest
{
  int dpos,spos;

  spos=x1+y1*320;
  dpos=x3+y3*320;

  asm {
    PUSH  ds
    MOV   ax,x2
    SUB   ax,x1
    INC   ax
    PUSH  ax
    SHR   ax,1
    MOV   x2,ax

    POP   bx
    MOV   ax,321
    SUB   ax,bx
    MOV   x1,ax

    MOV   ax,y2
    SUB   ax,y1
    MOV   y2,ax

    PUSH  ds
    MOV   ax,[source]
    MOV   ds,ax
    MOV   si,spos
    MOV   ax,[dest]
    MOV   es,ax
    MOV   di,dpos
    CLD
    XOR   bx,bx
  }
 _Rita: asm{
    MOV   cx,x2
    REP   movsw
    INC   bx
    ADD   di,x1
    ADD   si,x1
    CMP   bx,y2
    JL   _Rita

    POP   ds
  }
}

void waitvbl()
// vntar ut nrmaste elektronsvep
{
  _DX = 0x03DA;

  l1: asm {
	IN   al,dx
	AND  al,0x08
	JNZ  l1
      }

  l2: asm {
	IN   al,dx
	AND  al,0x08
	JZ   l2
      }
}

void putpixel(word x,word y,byte col,word where)
// ritar en pixel med frg 'col' i (x;y)
{
  asm {
    MOV   ax,[where]
    MOV   es,ax
    MOV   bx,[x]
    MOV   dx,[y]
    MOV   di,bx
    MOV   bx, dx    //              {; bx = dx}
    SHL   dx, 8
    SHL   bx, 6
    ADD   dx, bx    //              {; dx = dx + bx (ie y*320)}
    ADD   di, dx    //              {; finalise location}
    MOV   al, [col]
    STOSB
  }
}

int getpixel(word x,word y,word where)
// ger pixelfrgen i (x;y)
{
  int farg;
  asm {
    PUSH  ds
    MOV   ax, [where]
    MOV   ds, ax
    MOV   bx, [x]
    MOV   dx, [y]
    MOV   si, bx
    MOV   bx, dx    //              {; bx = dx}
    SHL   dx, 8
    SHL   bx, 6
    ADD   dx, bx    //              {; dx = dx + bx (ie y*320)}
    ADD   si, dx    //              {; finalise location}
    XOR	  ax,ax
    LODSB
    MOV   farg,ax
    POP   ds
  }
  return(farg);
}

int sgn(int a)
// returnerar -1, 0 eller +1 beroende p vrdet p 'a'
// anvnds av linefunktionen
{
  if (a > 0)  return +1;
  if (a < 0)  return -1;
  return 0;
}

void line(word a,word b,word c,word d,byte col,word where)
// drar ett streck frn (a;b) till (c;d) i frg 'col'
{
  int i,s,d1x,d1y,d2x,d2y,u,v,m,n;

  u = c - a;       // u = x2 - x1  (delta x)
  v = d - b;       // v = y2 - y1  (delta y)

  d1x = sgn(u);    // d1x = tecknet fr delta x
  d1y = sgn(v);    // d1y = tecknet fr delta y

  d2x = d1x;       // d2x = tecknet fr delta x
  d2y = 0;
  m = abs(u);      // m = positiv delta x
  n = abs(v);      // n = positiv delta y

  if (m <= n) {
    d2x = 0;
    d2y = sgn(v);  // d2y = tecknet fr delta y
    m = abs(v);    // m = positiv delta y
    n = abs(u);    // n = positiv delta x
  }
  s = m / 2;       // s = halva delta x/y

  for (i=0;i<m+1;i++) {
    putpixel(a,b,col,where);   // rita punkt i (a;b)
    s += n;
    if (s >= m) {
      s -= m;
      a += d1x;
      b += d1y;
    }
    else {
      a += d2x;
      b += d2y;
    }
  }
}

void box(word a,word b,word c,word d,byte col,word where)
// ritar en tom lda mellan (a;b) och (c:d) i frg 'col'
{
  line(a,b,a,d,col,where);
  line(a,d,c,d,col,where);
  line(c,d,c,b,col,where);
  line(c,b,a,b,col,where);
}

void bar(word a,word b,word c,word d,byte col,word where)
// ritar en fylld lda mellan (a;b) och (c:d) i frg 'col'
{
  int spos,bredd,lang;

  spos=a+(b<<8)+(b<<6);
  bredd=c-a+1;
  lang=320-bredd;
  d++;

  asm {
    PUSH  ds
    MOV   ax,[where]
    MOV   es,ax
    MOV   di,spos
    XOR   ax,ax
  }
 _Rita: asm{
    MOV   al,col
    MOV   cx,bredd
    REP   stosb
    ADD   di,lang
    INC   b
    MOV   bx,b
    MOV   ax,d
    CMP   bx,ax
    JL   _Rita

    POP   ds
  }
}

void recallpalette(pal pal1)
// gr paletten pal1 till aktuell
{
  int c;
  byte r,g,b;

  for(c=0;c<256;c++)
  {
    r=pal1[c][0];
    g=pal1[c][1];
    b=pal1[c][2];
    setcolor(c,r,g,b);
  }
}

void storepalette(pal &pal1)
// sparar aktuell palett i pal1
{
  int c;
  byte r,g,b;

  for(c=0;c<256;c++)
  {
    getcolor(c,r,g,b);
    pal1[c][0]=r;
    pal1[c][1]=g;
    pal1[c][2]=b;
  }
}

void setcolor(byte col,byte r,byte g,byte b)
// bestmmer frgen p 'col' med rd intensitet 'r', grn intensitet 'g'
// och bl intensitet 'b', r,g och b kan vara mellan 0 och 63
  {
    outp (0x03C8,col);
    outp (0x03C9,r);
    outp (0x03C9,g);
    outp (0x03C9,b);
  }

void getcolor(byte col,byte &r,byte &g,byte &b)
// ger frgen p 'col' med rd intensitet 'r', grn intensitet 'g'
// och bl intensitet 'b'
  {
    outp (0x03C7,col);
    r = inp (0x03C9);
    g = inp (0x03C9);
    b = inp (0x03C9);
  }

void setpalette(byte r,byte g,byte b)
// stter hela palette till en och samma frg
{
  for(int c=0;c<256;c++)
    setcolor(c,r,g,b);
}

int fadein(pal pal1)
// fadar ett steg mot pal1, returnerar 0 om ingen frg ndrades
{
  int p=0;
  byte r ,g ,b;
  byte r2,g2,b2;

  for(int c=0;c<256;c++)
  {
    getcolor(c,r,g,b);
    r2=r; g2=g; b2=b;
    if (r<pal1[c][0]) r++;
    if (g<pal1[c][1]) g++;
    if (b<pal1[c][2]) b++;
    if (r>pal1[c][0]) r--;
    if (g>pal1[c][1]) g--;
    if (b>pal1[c][2]) b--;
    waitvbl;
    setcolor(c,r,g,b);
    if (r!=r2 || g!=g2 || b!=b2) p++;
  }
  return(p);
}

int fadeout(byte r,byte g,byte b)
// fadar ett steg mot frgen rgb, returnerar 0 om ingen frg ndrades
{
  int p=0;
  byte r1,g1,b1;
  byte r2,g2,b2;

  for(int c=0;c<256;c++)
  {
    getcolor(c,r1,g1,b1);
    r2=r1; g2=g1; b2=b1;
    if (r1<r) r1++;
    if (g1<g) g1++;
    if (b1<b) b1++;
    if (r1>r) r1--;
    if (g1>g) g1--;
    if (b1>b) b1--;
    waitvbl;
    setcolor(c,r1,g1,b1);
    if (r1!=r2 || g1!=g2 || b1!=b2) p++;
  }
  return(p);
}

void makeicons(word &adr,byte far *&ICON)
// skapar en iconbank som kan kommas t med hjlp av
// 'adr' eller ICON
{
  ICON = (byte far *) farcalloc(48000,1);

  // kolla alltid om det finns tillrckligt med minne!
  if (ICON == NULL)
  {
    asm {
      MOV  ax,3
      INT  0x10
    }
    cout << "GROTESKT! Det finns inte nog med minne i denna burk!";
    farfree(ICON);
    exit(1);
  }

  adr = FP_SEG(ICON);
}

void makeicons32(word &adr,byte far *&ICON)
// skapar en iconbank som kan kommas t med hjlp av
// 'adr' eller ICON
{
  ICON = (byte far *) farcalloc(61440,1);

  // kolla alltid om det finns tillrckligt med minne!
  if (ICON == NULL)
  {
    asm {
      MOV  ax,3
      INT  0x10
    }
    cout << "GROTESKT! Det finns inte nog med minne i denna burk!";
    farfree(ICON);
    exit(1);
  }

  adr = FP_SEG(ICON);
}

void killicons(byte far *kill)
// frigr minnet som skrmen 'adr' upptog
{
  farfree(kill);
}

void killicons32(byte far *kill)
// frigr minnet som skrmen 'adr' upptog
{
  farfree(kill);
}

void puticon(int n,int x,int y,word DEST,word ICON)
// ritar ut en ikon som den r frn banken ICON till skrmen DEST
{
  int ipos,pos,stbredd,bredd,sthojd,hojd,xadd;
  int kbredd;

  kbredd=0; bredd=24; hojd=20; stbredd=0; sthojd=0; xadd=296;
  if (y>180) hojd=200-y;
  if (y<0) { sthojd=-y; hojd=20+y; }
  if (x>296) { bredd=24-(x-296); xadd=296+24-bredd; kbredd=24-bredd; }
  if (x<0) { stbredd=-x; xadd=296+stbredd; bredd=24-stbredd; kbredd=stbredd; }

  if (hojd>0 && bredd>0)
  {
    ipos=(n-1)*480+4+sthojd*24+stbredd;
    pos=x+(y+sthojd)*320+stbredd;
    asm {
      PUSH  ds
      MOV   ax,[ICON]
      MOV   ds,ax
      MOV   si,ipos
      MOV   ax,[DEST]
      MOV   es,ax
      MOV   di,pos
      CLD
      XOR   bx,bx
      }
     _Rita: asm {
      MOV   cx,bredd
      REP   movsb
      ADD   si,kbredd
      INC   bx
      ADD   di,xadd
      CMP   bx,hojd
      JL   _Rita

      POP   ds
    }
  }
}

void puticon_F(int n,int x,int y,word DEST,word ICON)
// ritar ut en ikon som den r frn banken ICON till skrmen DEST
{
  int ipos,pos;

  ipos=(n-1)*480+4;
  pos=x+y*320;
  asm {
    PUSH  ds
    MOV   ax,[ICON]
    MOV   ds,ax
    MOV   si,ipos
    MOV   ax,[DEST]
    MOV   es,ax
    MOV   di,pos
    CLD
    XOR   bx,bx
    }
   _Rita: asm {
    MOV   cx,12
    REP   movsw
    INC   bx
    ADD   di,296
    CMP   bx,20
    JL   _Rita
    POP   ds
  }
}

void puticon32(int n,int x,int y,word DEST,word ICON)
// ritar ut en ikon som den r frn banken ICON till skrmen DEST
{
  int ipos,pos;
  ipos=(n-1)*1024+4;
  pos=x+y*320;
  asm {
    PUSH  ds
    MOV   ax,[ICON]
    MOV   ds,ax
    MOV   si,ipos
    MOV   ax,[DEST]
    MOV   es,ax
    MOV   di,pos
    CLD
    XOR   bx,bx
    }
   _Rita: asm {
    MOV   cx,16
    REP   movsw
    INC   bx
    ADD   di,288
    CMP   bx,32
    JL   _Rita

    POP   ds
  }
}

void puticon_M(int n,int x,int y,word DEST,word ICON)
// ritar ut en ikon utan bakgrundsfrg frn banken ICON till skrmen DEST
{
  int ipos,pos;

  ipos=(n-1)*480+4;
  pos=x+y*320;
  asm{
    PUSH  ds
    MOV   ax,[ICON]
    MOV   ds,ax
    MOV   si,ipos
    MOV   ax,[DEST]
    MOV   es,ax
    MOV   di,pos
    CLD
    XOR   bx,bx
    XOR   cx,cx
    JMP   _Rita
    }
   _Masking: asm{
    INC   si
    INC   di
    JMP   _Next
    }
   _Rita: asm{
    MOV   dl,ds:[si]
    CMP   dl,0
    JZ    _Masking
    MOVSB
    }
   _Next: asm{
    INC   cx
    CMP   cx,24
    JNZ   _Rita

    INC   bx
    ADD   di,296
    XOR   cx,cx
    CMP   bx,20
    JL    _Rita

    POP   ds
  }
}

void puticon_M32(int n,int x,int y,word DEST,word ICON)
// ritar ut en ikon utan bakgrundsfrg frn banken ICON till skrmen DEST
{
  int ipos,pos;

  ipos=(n-1)*1024+4;
  pos=x+y*320;
  asm{
    PUSH  ds
    MOV   ax,[ICON]
    MOV   ds,ax
    MOV   si,ipos
    MOV   ax,[DEST]
    MOV   es,ax
    MOV   di,pos
    CLD
    XOR   bx,bx
    XOR   cx,cx
    JMP   _Rita
    }
   _Masking: asm{
    INC   si
    INC   di
    JMP   _Next
    }
   _Rita: asm{
    MOV   dl,ds:[si]
    CMP   dl,0
    JZ    _Masking
    MOVSB
    }
   _Next: asm{
    INC   cx
    CMP   cx,32
    JNZ   _Rita

    INC   bx
    ADD   di,288
    XOR   cx,cx
    CMP   bx,32
    JL    _Rita

    POP   ds
  }
}

void puticon_C(int n,int x,int y,byte col,word DEST,word ICON)
// ritar ut en ikon utan bakgrundsfrg frn banken ICON till skrmen DEST
{
  int ipos,pos;

  ipos=(n-1)*480+4;
  pos=x+y*320;
  asm{
    PUSH  ds
    MOV   ax,[ICON]
    MOV   ds,ax
    MOV   si,ipos
    MOV   ax,[DEST]
    MOV   es,ax
    MOV   di,pos
    CLD
    XOR   bx,bx
    XOR   cx,cx
    JMP   _Rita
    }
   _Masking: asm{
    INC   si
    INC   di
    JMP   _Next
    }
   _Rita: asm{
    MOV   dl,ds:[si]
    CMP   dl,0
    JZ    _Masking
    MOV   al,col
    STOSB
    INC   si
    }
   _Next: asm{
    INC   cx
    CMP   cx,24
    JNZ   _Rita

    INC   bx
    ADD   di,296
    XOR   cx,cx
    CMP   bx,20
    JL    _Rita

    POP   ds
  }
}

void puticon_MZ(int n,int x,int y,word DEST,word ICON,word ZON)
// ritar ut en ikon utan bakgrundsfrg frn banken ICON till skrmen DEST
// men bakom ZON
{
  int ipos,pos;

  ipos=(n-1)*480+4;
  pos=x+y*320;
  asm{
    PUSH  ds
    MOV   ax,[ICON]
    MOV   ds,ax
    MOV   si,ipos
    MOV   ax,[DEST]
    MOV   es,ax
    MOV   di,pos
    CLD
    XOR   bx,bx
    XOR   cx,cx
    JMP   _Rita
    }
   _Masking: asm{
    INC   si
    INC   di
    JMP   _Next
    }
   _Rita: asm{
    MOV   ax,[ZON]
    MOV   es,ax
    MOV   dl,es:[di]
    CMP   dl,255
    JZ    _Masking

    MOV   dl,ds:[si]
    CMP   dl,0
    JZ    _Masking
    MOV   ax,[DEST]
    MOV   es,ax
    MOVSB
    }
   _Next: asm{
    INC   cx
    CMP   cx,24
    JNZ   _Rita

    INC   bx
    ADD   di,296
    XOR   cx,cx
    CMP   bx,20
    JL    _Rita

    POP   ds
  }
}

void puticon_H(int n,int x,int y,word DEST,word ICON)
// ritar ut en ikon som den r
// frn banken ICON till skrmen DEST dock size*0.25
{
  int ipos,pos;
  ipos=(n-1)*480+4;
  pos=x+y*320;
  asm{
    PUSH  ds
    MOV   ax,[ICON]
    MOV   ds,ax
    MOV   si,ipos
    MOV   ax,[DEST]
    MOV   es,ax
    MOV   di,pos
    CLD
    XOR   bx,bx
    XOR   cx,cx
    }
   _Rita: asm{
    MOV   dl,ds:[si]
    CMP   dl,0
    MOVSB
    INC   si
    INC   cx
    CMP   cx,12
    JNZ   _Rita

    INC   bx
    ADD   si,24
    ADD   di,308
    XOR   cx,cx
    CMP   bx,10
    JL    _Rita

    POP   ds
  }
}

void putshadow(int x,int y,word DEST)
// ritar en skugga p skrmen DEST
{
  int pos;

  pos=x+y*320;
  asm{
    PUSH  ds
    MOV   ax,[DEST]
    MOV   ds,ax
    MOV   si,pos
    MOV   di,pos
    XOR   bx,bx
    XOR   cx,cx
    JMP   _Rita
    }
   _Rita: asm{
    MOV   dl,ds:[si]
    DEC   dl
    DEC   dl
    MOV   ds:[si],dl
    INC   si
    INC   cx
    CMP   cx,10
    JNZ   _Rita

    INC   bx
    ADD   si,310
    XOR   cx,cx
    CMP   bx,20
    JL    _Rita

    POP   ds
  }
}

void loadicons(char *fnamn,byte far *ICON,pal &palett)
// laddar in en ICN-fil i ICON med paletten i pal
{
  FILE *fp;

  fp=fopen(fnamn,"rb");
  fread(ICON,48000,1,fp);
  fread(palett,sizeof(pal),1,fp);
  fclose(fp);
}

void loadicons32(char *fnamn,byte far *ICON,pal &palett)
// laddar in en ICN-fil i ICON med paletten i pal
{
  FILE *fp;

  fp=fopen(fnamn,"rb");
  fread(ICON,61440,1,fp);
  fread(palett,sizeof(pal),1,fp);
  fclose(fp);
}

void makefont(word &adr,byte far *&FONT)
// skapar en iconbank som kan kommas t med hjlp av
// 'adr' eller FONT
{
  FONT = (byte far *) farcalloc(6144,1);

  // kolla alltid om det finns tillrckligt med minne!
  if (FONT == NULL)
  {
    asm {
      MOV  ax,3
      INT  0x10
    }
    cout << "GROTESKT! Det finns inte nog med minne i denna burk!";
    farfree(FONT);
    exit(1);
  }

  adr = FP_SEG(FONT);
}

void killfont(byte far *kill)
// frigr minnet som skrmen 'adr' upptog
{
  farfree(kill);
}

void write(char* txt,int x,int y,int col,word FONT,word DEST)
// skriver ut txt till DEST
{
  int i=0;
  while (txt[i]!='\0')
  {
    text(txt[i],x+i*8,y,col,FONT,DEST);
    i++;
  }
}

void write_O(char* txt,int x,int y,int col,int ocol,word FONT,word DEST)
// skriver ut txt till DEST
{
  write(txt,x-1,y,ocol,FONT,DEST);
  write(txt,x+1,y,ocol,FONT,DEST);
  write(txt,x,y-1,ocol,FONT,DEST);
  write(txt,x,y+1,ocol,FONT,DEST);
  write(txt,x,y,col,FONT,DEST);
}

void text(int let,int x,int y,int col,word FONT,word DEST)
// skriver ut en bosktav utan bakgrundsfrg
// frn banken FONT till skrmen DEST
{
  int fpos,pos;

  fpos=(let-32)*64;
  pos=x+y*320;
  asm{
    PUSH  ds
    MOV   ax,[FONT]
    MOV   ds,ax
    MOV   si,fpos
    MOV   ax,[DEST]
    MOV   es,ax
    MOV   di,pos
    CLD
    XOR   bx,bx
    XOR   cx,cx
    JMP   _Rita
    }
   _Masking: asm{
    INC   si
    INC   di
    JMP   _Next
    }
   _NyFarg: asm{
    MOV   ax,col
    STOSB
    INC   si
    JMP  _Next
    }
   _Rita: asm{
    MOV   dl,ds:[si]
    CMP   dl,0
    JZ    _Masking
    CMP   col,0
    JNZ   _NyFarg
    MOVSB
    }
   _Next: asm{
    INC   cx
    CMP   cx,8
    JNZ   _Rita
    INC   bx
    ADD   di,312
    XOR   cx,cx
    CMP   bx,8
    JL    _Rita
    POP   ds
  }
}

void loadfont(char *fnamn,byte far *FONT,pal &palett)
// laddar in en FNT-fil i FONT med paletten i pal
{
  FILE *fp;

  fp=fopen(fnamn,"rb");
  fread(FONT,6144,1,fp);
  fread(palett,sizeof(pal),1,fp);
  fclose(fp);
}
